package google.visualization;

/**
 *  Copyright 2016 Weathertop Consulting, LLC
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
import jsinterop.annotations.JsMethod;
import jsinterop.annotations.JsOverlay;
import jsinterop.annotations.JsPackage;
import jsinterop.annotations.JsProperty;
import jsinterop.annotations.JsType;


/**
 * Class generated by reading: http://www.google.com/uds/modules/gviz/gviz-api.js
 * using
 *
 * @author <a href="mailto:Roland.Schweitzer@gmail.com">Roland Schweitzer</a>
 */
@JsType(isNative = true)
public class DataTable {

    public DataTable() {

    }
    public DataTable(String datatable) {

    }

@JsMethod
public native void getNumberOfRows();

@JsMethod
public native void getNumberOfColumns();

@JsMethod
public native DataTable clone();

@JsMethod
public native void getColumnId(int columnIndex);
@JsMethod
public native void getColumnIndex(String columnId);
@JsMethod
public native void getColumnLabel(int columnIndex);
@JsMethod
public native void getColumnPattern(int columnIndex);
@JsMethod
public native void getColumnRole(int columnIndex);
@JsMethod
public native void getColumnType(int columnIndex);
@JsMethod
public native void getValue(int rowIndex, int columnIndex);
@JsMethod
public native void getFormattedValue(int rowIndex, int columnIndex);
@JsMethod
public native void getProperty(int rowIndex, int columnIndex, String property);
@JsMethod
public native void getProperties(int rowIndex, int columnIndex);
@JsMethod
public native void getTableProperties();

@JsMethod
public native void getTableProperty(String property);
@JsMethod
public native void setTableProperties(String properties);
@JsMethod
public native void setTableProperty(String property, String value);
@JsMethod
public native void setValue(int rowIndex, int columnIndex, String value);
@JsMethod
public native void setFormattedValue(int rowIndex, int columnIndex, String formattedValue);
@JsMethod
public native void setProperties(int rowIndex, int columnIndex, String properties);
@JsMethod
public native void setProperty(int rowIndex, int columnIndex, String property, String value);
@JsMethod
public native void setCell(int rowIndex, int columnIndex);
@JsMethod
public native void setCell(int rowIndex, int columnIndex, String opt_value);
@JsMethod
public native void setCell(int rowIndex, int columnIndex, String opt_value, String opt_formattedValue);
@JsMethod
public native void setCell(int rowIndex, int columnIndex, String opt_value, String opt_formattedValue, String opt_properties);
@JsMethod
public native void setRowProperties(int rowIndex, String properties);
@JsMethod
public native void setRowProperty(int rowIndex, String property, String value);
@JsMethod
public native void getRowProperty(int rowIndex, String property);
@JsMethod
public native void getRowProperties(int rowIndex);
@JsMethod
public native void setColumnLabel(int columnIndex, String newLabel);
@JsMethod
public native void setColumnProperties(int columnIndex, String properties);
@JsMethod
public native void setColumnProperty(int columnIndex, String property, String value);
@JsMethod
public native void getColumnProperty(int columnIndex, String property);
@JsMethod
public native void getColumnProperties(int columnIndex);
@JsMethod
public native void insertColumn(int atColIndex, String type);
@JsMethod
public native void insertColumn(int atColIndex, String type, String opt_label);
@JsMethod
public native void insertColumn(int atColIndex, String type, String opt_label, String opt_id);
@JsMethod
public native void addColumn(String type);
@JsMethod
public native void addColumn(String type, String opt_label);
@JsMethod
public native void addColumn(String type, String opt_label, String opt_id);
@JsMethod
public native void addColumn(Column column);
@JsMethod
public native void insertRows(int atRowIndex, Object[][] numOrArray);
@JsMethod
public native void addRows(Object[][] numOrArray);
@JsMethod
public native void addRow();
@JsMethod
public native void addRow(Object[] opt_cellArray);
@JsMethod
public native void getColumnRange(int columnIndex);
@JsMethod
public native void getSortedRows(String sortColumns);
@JsMethod
public native void sort(String sortColumns);
@JsMethod
public native void getDistinctValues(String column);
@JsMethod
public native void getFilteredRows(String columnFilters);
@JsMethod
public native void removeRows(int fromRowIndex, String numRows);
@JsMethod
public native void removeRow(int rowIndex);
@JsMethod
public native void removeColumns(int fromColIndex, String numCols);
@JsMethod
public native void removeColumn(int colIndex);
@JsMethod
public native void toJSON();
    @JsType(isNative=true,namespace= JsPackage.GLOBAL,name="Object")
    public static class Column {
        @JsProperty
        String type;
        @JsProperty
        String label;
        @JsProperty
        String id;
        @JsProperty
        String role;
        @JsOverlay
        public final String getType() {
            return type;
        }
        @JsOverlay
        public final void setType(String type) {
            this.type = type;
        }
        @JsOverlay
        public final String getLabel() {
            return label;
        }
        @JsOverlay
        public final void setLabel(String label) {
            this.label = label;
        }
        @JsOverlay
        public final String getId() {
            return id;
        }
        @JsOverlay
        public final void setId(String id) {
            this.id = id;
        }
        @JsOverlay
        public final String getRole() {
            return role;
        }
        @JsOverlay
        public final void setRole(String role) {
            this.role = role;
        }
    }
}
